Skip to main content

Filtering

This guide covers how to narrow the calendar to a subset of events without changing the source data: apply a predicate, stack independent filters, or wire a sidebar of group toggles.

How filtering works​

Filtering is a view concern. The calendar keeps the full event list in its store and applies one or more predicates when it builds the visible data.

The pieces involved:

  • state.filters - a map of named slots, each holding one predicate (event) => boolean.
  • filter-events - the action that writes a predicate into a slot or removes it.
  • tag - the slot name. One tag owns one slot. Different tags stack.
  • onfilterevents - an observer prop that fires whenever the action runs.

The rules are simple:

  • Writing a new predicate to the same tag replaces the old one.
  • Different tags combine with logical AND - an event renders only if every active predicate returns true.
  • Untagged calls land in a single shared slot named _default.
  • Sending filter: null (or omitting it) clears the matching tag, or every slot when no tag is given.

Predicates should be pure boolean checks. The store iterates them in insertion order, but the contract is "all must pass," not ordered side effects.

Applying a filter​

Dispatch filter-events through the calendar API via api.exec with a predicate function. The init callback gives you a handle to that API:

<script lang="ts">
import { Calendar } from "@svar-ui/svelte-calendar";

let api;

function onlyWork() {
api.exec("filter-events", {
filter: e => e.calendarId === "work",
});
}

function clearFilter() {
api.exec("filter-events", {});
}
</script>

<button onclick={onlyWork}>Show work only</button>
<button onclick={clearFilter}>Clear</button>

<Calendar {events} {date} init={obj => (api = obj)} />

The predicate receives one event at a time and keeps it when it returns true. Sending {} (or { filter: null }) clears every active slot.

Stacking filters with tags​

When two controls produce independent predicates, give each its own tag:

api.exec("filter-events", {
filter: e => e.calendarId === "work",
tag: "calendar",
});

api.exec("filter-events", {
filter: e => (e.text ?? "").toLowerCase().includes("review"),
tag: "search",
});

Both predicates stay active. The calendar shows events that match calendar AND search. Clearing one tag leaves the other in place:

api.exec("filter-events", { tag: "search" });

Using FilterQuery​

FilterQuery from @svar-ui/svelte-filter produces a structured query value that you turn into a predicate via createFilter:

<script lang="ts">
import { Calendar } from "@svar-ui/svelte-calendar";
import { FilterQuery, createFilter } from "@svar-ui/svelte-filter";

let api;

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

function applyFilter({ value }) {
api.exec("filter-events", { filter: createFilter(value, {}, fields) });
}
</script>

<FilterQuery {fields} onchange={applyFilter} placeholder="type a query" />
<Calendar {events} {date} init={obj => (api = obj)} />

createFilter returns a (event) => boolean predicate built from the query value and the field definitions, ready to hand to filter-events.

Using FilterBuilder​

FilterBuilder exposes a structured UI for the same filter shape. Wire it the same way - the only change is the component:

<script lang="ts">
import { Calendar } from "@svar-ui/svelte-calendar";
import { FilterBuilder, createFilter } from "@svar-ui/svelte-filter";

let api;

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

function applyFilter({ value }) {
api.exec("filter-events", { filter: createFilter(value) });
}
</script>

<FilterBuilder {fields} type="line" onchange={applyFilter} />
<Calendar {events} {date} init={obj => (api = obj)} />

Any UI that produces a (event) => boolean works the same way. The calendar contract starts and ends at filter-events.

calendar with the CalendarPanel sidebar showing checkboxes for work, home, and holiday groups filtering the visible events

Group toggles via CalendarPanel​

CalendarPanel renders calendar-group checkboxes and dispatches filter-events for you under its own calendar-panel tag, so it stacks with any predicate you push from your own UI. See Calendar groups for the full setup.

Observing filter activity​

Use onfilterevents to mirror filter state to analytics, the URL, or external badges:

<Calendar
{events}
{date}
onfilterevents={p => console.log("filter changed", p.tag, !!p.filter)}
/>

This callback observes the action - it does not apply the filter. The store has already updated state.filters by the time it fires.

Skip to main content

Filtering

This guide covers how to narrow the calendar to a subset of events without changing the source data: apply a predicate, stack independent filters, or wire a sidebar of group toggles.

How filtering works​

Filtering is a view concern. The calendar keeps the full event list in its store and applies one or more predicates when it builds the visible data.

The pieces involved:

  • state.filters - a map of named slots, each holding one predicate (event) => boolean.
  • filter-events - the action that writes a predicate into a slot or removes it.
  • tag - the slot name. One tag owns one slot. Different tags stack.
  • onFilterEvents - an observer prop that fires whenever the action runs.

The rules are simple:

  • Writing a new predicate to the same tag replaces the old one.
  • Different tags combine with logical AND - an event renders only if every active predicate returns true.
  • Untagged calls land in a single shared slot named _default.
  • Sending filter: null (or omitting it) clears the matching tag, or every slot when no tag is given.

Predicates should be pure boolean checks. The store iterates them in insertion order, but the contract is "all must pass," not ordered side effects.

Applying a filter​

Dispatch filter-events through the calendar API via api.exec with a predicate function. The init callback gives you a handle to that API:

import { Calendar } from "@svar-ui/react-calendar";
import { useRef } from "react";

function App() {
const apiRef = useRef(null);

const onlyWork = () => {
apiRef.current.exec("filter-events", {
filter: e => e.calendarId === "work",
});
};

const clearFilter = () => {
apiRef.current.exec("filter-events", {});
};

return (
<>
<button onClick={onlyWork}>Show work only</button>
<button onClick={clearFilter}>Clear</button>

<Calendar events={events} date={date} init={obj => (apiRef.current = obj)} />
</>
);
}

The predicate receives one event at a time and keeps it when it returns true. Sending {} (or { filter: null }) clears every active slot.

Stacking filters with tags​

When two controls produce independent predicates, give each its own tag:

api.exec("filter-events", {
filter: e => e.calendarId === "work",
tag: "calendar",
});

api.exec("filter-events", {
filter: e => (e.text ?? "").toLowerCase().includes("review"),
tag: "search",
});

Both predicates stay active. The calendar shows events that match calendar AND search. Clearing one tag leaves the other in place:

api.exec("filter-events", { tag: "search" });

Using FilterQuery​

FilterQuery from @svar-ui/react-filter produces a structured query value that you turn into a predicate via createFilter:

import { Calendar } from "@svar-ui/react-calendar";
import { FilterQuery, createFilter } from "@svar-ui/react-filter";
import { useRef } from "react";

function App() {
const apiRef = useRef(null);

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

const applyFilter = ({ value }) => {
apiRef.current.exec("filter-events", { filter: createFilter(value, {}, fields) });
};

return (
<>
<FilterQuery fields={fields} onChange={applyFilter} placeholder="type a query" />
<Calendar events={events} date={date} init={obj => (apiRef.current = obj)} />
</>
);
}

createFilter returns a (event) => boolean predicate built from the query value and the field definitions, ready to hand to filter-events.

Using FilterBuilder​

FilterBuilder exposes a structured UI for the same filter shape. Wire it the same way - the only change is the component:

import { Calendar } from "@svar-ui/react-calendar";
import { FilterBuilder, createFilter } from "@svar-ui/react-filter";
import { useRef } from "react";

function App() {
const apiRef = useRef(null);

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

const applyFilter = ({ value }) => {
apiRef.current.exec("filter-events", { filter: createFilter(value) });
};

return (
<>
<FilterBuilder fields={fields} type="line" onChange={applyFilter} />
<Calendar events={events} date={date} init={obj => (apiRef.current = obj)} />
</>
);
}

Any UI that produces a (event) => boolean works the same way. The calendar contract starts and ends at filter-events.

calendar with the CalendarPanel sidebar showing checkboxes for work, home, and holiday groups filtering the visible events

Group toggles via CalendarPanel​

CalendarPanel renders calendar-group checkboxes and dispatches filter-events for you under its own calendar-panel tag, so it stacks with any predicate you push from your own UI. See Calendar groups for the full setup.

Observing filter activity​

Use onFilterEvents to mirror filter state to analytics, the URL, or external badges:

<Calendar
events={events}
date={date}
onFilterEvents={p => console.log("filter changed", p.tag, !!p.filter)}
/>

This callback observes the action - it does not apply the filter. The store has already updated state.filters by the time it fires.

Skip to main content

Filtering

This guide covers how to narrow the calendar to a subset of events without changing the source data: apply a predicate, stack independent filters, or wire a sidebar of group toggles.

How filtering works​

Filtering is a view concern. The calendar keeps the full event list in its store and applies one or more predicates when it builds the visible data.

The pieces involved:

  • state.filters - a map of named slots, each holding one predicate (event) => boolean.
  • filter-events - the action that writes a predicate into a slot or removes it.
  • tag - the slot name. One tag owns one slot. Different tags stack.
  • onfilterevents - an observer prop that fires whenever the action runs.

The rules are simple:

  • Writing a new predicate to the same tag replaces the old one.
  • Different tags combine with logical AND - an event renders only if every active predicate returns true.
  • Untagged calls land in a single shared slot named _default.
  • Sending filter: null (or omitting it) clears the matching tag, or every slot when no tag is given.

Predicates should be pure boolean checks. The store iterates them in insertion order, but the contract is "all must pass," not ordered side effects.

Applying a filter​

Dispatch filter-events through the calendar API via api.exec with a predicate function. The init callback gives you a handle to that API:

<script setup lang="ts">
import { Calendar } from "@svar-ui/vue-calendar";
import { ref } from "vue";

let api;

function onlyWork() {
api.exec("filter-events", {
filter: e => e.calendarId === "work",
});
}

function clearFilter() {
api.exec("filter-events", {});
}
</script>

<template>
<button :onclick="onlyWork">Show work only</button>
<button :onclick="clearFilter">Clear</button>

<Calendar :events="events" :date="date" :init="obj => (api = obj)" />
</template>

The predicate receives one event at a time and keeps it when it returns true. Sending {} (or { filter: null }) clears every active slot.

Stacking filters with tags​

When two controls produce independent predicates, give each its own tag:

api.exec("filter-events", {
filter: e => e.calendarId === "work",
tag: "calendar",
});

api.exec("filter-events", {
filter: e => (e.text ?? "").toLowerCase().includes("review"),
tag: "search",
});

Both predicates stay active. The calendar shows events that match calendar AND search. Clearing one tag leaves the other in place:

api.exec("filter-events", { tag: "search" });

Using FilterQuery​

FilterQuery from @svar-ui/vue-filter produces a structured query value that you turn into a predicate via createFilter:

<script setup lang="ts">
import { Calendar } from "@svar-ui/vue-calendar";
import { FilterQuery, createFilter } from "@svar-ui/vue-filter";

let api;

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

function applyFilter({ value }) {
api.exec("filter-events", { filter: createFilter(value, {}, fields) });
}
</script>

<template>
<FilterQuery :fields="fields" :onchange="applyFilter" placeholder="type a query" />
<Calendar :events="events" :date="date" :init="obj => (api = obj)" />
</template>

createFilter returns a (event) => boolean predicate built from the query value and the field definitions, ready to hand to filter-events.

Using FilterBuilder​

FilterBuilder exposes a structured UI for the same filter shape. Wire it the same way - the only change is the component:

<script setup lang="ts">
import { Calendar } from "@svar-ui/vue-calendar";
import { FilterBuilder, createFilter } from "@svar-ui/vue-filter";

let api;

const fields = [
{ id: "text", label: "Text", type: "text" },
{ id: "start", label: "Start Date", type: "date" },
{ id: "end", label: "End Date", type: "date" },
];

function applyFilter({ value }) {
api.exec("filter-events", { filter: createFilter(value) });
}
</script>

<template>
<FilterBuilder :fields="fields" type="line" :onchange="applyFilter" />
<Calendar :events="events" :date="date" :init="obj => (api = obj)" />
</template>

Any UI that produces a (event) => boolean works the same way. The calendar contract starts and ends at filter-events.

calendar with the CalendarPanel sidebar showing checkboxes for work, home, and holiday groups filtering the visible events

Group toggles via CalendarPanel​

CalendarPanel renders calendar-group checkboxes and dispatches filter-events for you under its own calendar-panel tag, so it stacks with any predicate you push from your own UI. See Calendar groups for the full setup.

Observing filter activity​

Use onfilterevents to mirror filter state to analytics, the URL, or external badges:

<template>
<Calendar
:events="events"
:date="date"
:onfilterevents="p => console.log('filter changed', p.tag, !!p.filter)"
/>
</template>

This callback observes the action - it does not apply the filter. The store has already updated state.filters by the time it fires.